﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using Infragistics.Win.UltraWinGrid;

namespace MaxVision_Quickbooks_Manager
{
    public partial class frmTimeManager : Form
    {
        public frmTimeManager()
        {
            Cursor.Current = Cursors.WaitCursor;

            InitializeComponent();
        }

        private void frmTimeManager_Load(object sender, EventArgs e)
        {
            // TODO: This line of code loads data into the 'mVDBDataSet.vewProjectTasks' table. You can move, or remove it, as needed.
            this.vewProjectTasksTableAdapter.Fill(this.mVDBDataSet.vewProjectTasks);
            // TODO: This line of code loads data into the 'mVDBDataSet.vewTimeLogEntryAdmin' table. You can move, or remove it, as needed.
            //this.vewTimeLogEntryAdminTableAdapter.Fill(this.mVDBDataSet.vewTimeLogEntryAdmin);

            // TODO: This line of code loads data into the 'mVDBDataSet.mvsp_qryMonthsForSelector' table. You can move, or remove it, as needed.
            this.mvsp_qryMonthsForSelectorTableAdapter.Fill(this.mVDBDataSet.mvsp_qryMonthsForSelector);

            this.monthSelectorUltraCombo.Value = MaxVision_Utilities.GetMonthStartDate(DateTime.Now.AddDays(-6.0));

            //this.mvsp_qryEmployeeMonthApprovedListTableAdapter.Fill(this.mVDBDataSet.mvsp_qryEmployeeMonthApprovedList, (DateTime)this.ultraCombo_MonthSelector.Value);

            this.MapKeysForGrid(this.employeesUltraGrid);
            this.MapKeysForGrid(this.vewTimeLogEntryAdminUltraGrid);

            Cursor.Current = Cursors.Default;
        }

        private void frmTimeManager_FormClosing(object sender, FormClosingEventArgs e)
        {
            this.vewTimeLogEntryAdminTableAdapter.Update(this.mVDBDataSet.vewTimeLogEntryAdmin);
        }

        private void MapKeysForGrid(UltraGrid ultraGrid)
        {
            // Return key = go to next row.
            Infragistics.Win.UltraWinGrid.GridKeyActionMapping keyMapping =
                new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Return, UltraGridAction.NextRow, 0, 0, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);

            // Return key = go to activate cell.
            keyMapping = new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Return, UltraGridAction.ActivateCell, 0, 0, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);

            // Return key = enter edit mode.
            keyMapping = new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Return, UltraGridAction.EnterEditMode, 0, 0, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);

            // Force Up key to go to prev row.
            keyMapping = new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Up, UltraGridAction.AboveCell, 0, UltraGridState.InEdit, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);

            // Up key = go to activate cell.
            keyMapping = new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Up, UltraGridAction.ActivateCell, 0, 0, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);

            // Up key = enter edit mode.
            keyMapping = new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Up, UltraGridAction.EnterEditMode, 0, 0, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);

            // Force Down key to go to next row.
            keyMapping = new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Down, UltraGridAction.BelowCell, 0, UltraGridState.InEdit, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);

            // Down key = go to activate cell.
            keyMapping = new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Down, UltraGridAction.ActivateCell, 0, 0, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);

            // Down key = enter edit mode.
            keyMapping = new Infragistics.Win.UltraWinGrid.GridKeyActionMapping(Keys.Down, UltraGridAction.EnterEditMode, 0, 0, 0, 0);
            ultraGrid.KeyActionMappings.Add(keyMapping);
        }

        //private void employeesUltraGrid_AfterCellUpdate(object sender, Infragistics.Win.UltraWinGrid.CellEventArgs e)
        //{
        //    if (e.Cell.Column.Key != "Employee")
        //        return;

        //    UltraGridCell ultraGridCell = e.Cell as UltraGridCell;

        //    if ((int)ultraGridCell.Row.Cells["MonthApproved"].Value == 0)
        //    {
        //        ultraGridCell.Appearance.BackColor = Color.Yellow;
        //        ultraGridCell.Appearance.ForeColor = Color.Red;
        //    }
        //    else
        //    {
        //    }
        //}

        private void monthSelectorUltraCombo_TextChanged(object sender, EventArgs e)
        {
            this.workHoursInMonthUltraLabel.Text = "Work hours in " + 
                                                    ((DateTime)this.monthSelectorUltraCombo.Value).ToString("MMM, yyyy") + ": " +
                                                    (8 * MaxVision_Utilities.WorkDaysInMonth((DateTime)this.monthSelectorUltraCombo.Value));

            this.mvsp_qryEmployeeMonthApprovedListTableAdapter.Fill(this.mVDBDataSet.mvsp_qryEmployeeMonthApprovedList, (DateTime)this.monthSelectorUltraCombo.Value);

            UpdateData();

            Filter_vewTimeLogEntryAdmin();
        }

        private void Filter_vewTimeLogEntryAdmin()
        {
            if (this.employeesUltraGrid.ActiveRow == null)
                this.vewTimeLogEntryAdminTableAdapter.Fill(this.mVDBDataSet.vewTimeLogEntryAdmin, "", DateTime.Parse("1/1/1901"));
            else
                this.vewTimeLogEntryAdminTableAdapter.Fill(this.mVDBDataSet.vewTimeLogEntryAdmin, this.employeesUltraGrid.ActiveRow.Cells["UserID"].Value.ToString(), (DateTime)this.monthSelectorUltraCombo.Value);

            GridUtilities.AutofitColumns(this.vewTimeLogEntryAdminUltraGrid, 200);
        }

        private void employeesUltraGrid_AfterRowActivate(object sender, EventArgs e)
        {
            UpdateData();

            this.Filter_vewTimeLogEntryAdmin();
        }

        private void frmTimeManager_Shown(object sender, EventArgs e)
        {
            this.employeesUltraGrid.Focus();
        }

        private void vewTimeLogEntryAdminUltraGrid_BeforeRowUpdate(object sender, CancelableRowEventArgs e)
        {
            // If UserID is null or empty...
            if (String.IsNullOrWhiteSpace(e.Row.Cells["UserID"].Value.ToString()))
            {
                // If there is now active row in the employee list, or there is now UserID in the active row...
                if (this.employeesUltraGrid.ActiveRow == null || String.IsNullOrWhiteSpace(this.employeesUltraGrid.ActiveRow.Cells["UserID"].Value.ToString()))
                {
                    MessageBox.Show("Can't add a time record because no Employee is selected.");

                    e.Cancel = true;
                }

                // Default the UserID to selected employee.
                e.Row.Cells["UserID"].Value = this.employeesUltraGrid.ActiveRow.Cells["UserID"].Value;
            }
        }
        
        private void vewTimeLogEntryAdminUltraGrid_AfterRowUpdate(object sender, RowEventArgs e)
        {
            this.UpdateData();
        }

        private void UpdateData()
        {
            try
            {
                this.Validate();
                this.vewTimeLogEntryAdminBindingSource.EndEdit();
                this.vewTimeLogEntryAdminTableAdapter.Update(this.mVDBDataSet.vewTimeLogEntryAdmin);
                //MessageBox.Show("Update successful");
            }
            catch (System.Exception ex)
            {
                MessageBox.Show("Update failed");
            } 
        }

        private void gitErDoneUltraButton_Click(object sender, EventArgs e)
        {
            this.UpdateData();
        }

        private void summaryForMonthUltraButton_Click(object sender, EventArgs e)
        {
            this.UpdateData();
        }

        private void employeeTimeReportUltraButton_Click(object sender, EventArgs e)
        {
            this.UpdateData();
        }

        private void fillMissingDaysUltraButton_Click(object sender, EventArgs e)
        {
            this.UpdateData();
        }

        private void fillHolidaysUltraButton_Click(object sender, EventArgs e)
        {
            this.UpdateData();
        }

        private void exportEmployeeUltraButton_Click(object sender, EventArgs e)
        {
            this.UpdateData();
        }

        private void exportAllUltraButton_Click(object sender, EventArgs e)
        {
            this.UpdateData();
        }
    }
}
